close all; clear all;

[audioM,fs] = audioread('c06ss.wav');
[audioF,fs] = audioread('c05ss.wav');


T = 1/fs;
N = round(60*1.25);

%% synthesize window
winAmt = .75;
winLen = floor(winAmt*N);
if(mod(winLen,2)==1)
    winLen = winLen-1;
end
halfWinLen = winLen/2;
win = hamming(winLen);
winF = win(1:halfWinLen);
winB = win(halfWinLen+1:end);
jump = N-halfWinLen;

%% Buffers to store samples for overlapping
currWinBufi = zeros(halfWinLen,1);
currEBufi = zeros(halfWinLen,1);
currWinBufii = zeros(halfWinLen,1);
currEBufii = zeros(halfWinLen,1);
currWinBufiii = zeros(halfWinLen,1);
currEBufiii = zeros(halfWinLen,1);
currWinBufiv = zeros(halfWinLen,1);
currEBufiv = zeros(halfWinLen,1);

normLen = N-winLen;
audioMd = [zeros(halfWinLen,1); audioM];

numreps = floor(length(audioMd)/jump)-1;
xW = 0;

%% Vectors to read output signal to
reci = zeros(length(audioMd),1);
excitationi = zeros(length(audioMd),1);
recii = zeros(length(audioMd),1);
excitationii = zeros(length(audioMd),1);
reciii = zeros(length(audioMd),1);
excitationiii = zeros(length(audioMd),1);
reciv = zeros(length(audioMd),1);
excitationiv = zeros(length(audioMd),1);

for i = 1:numreps
    xW = audioMd((i-1)*jump+1:(i-1)*jump+N);           %% Read entire buffer
    xH = xW;                                           %% Preserve non-windowed portion of buffer
    xH(1:halfWinLen) = xW(1:halfWinLen).* winF;         %% Window first half
    xH(end-halfWinLen+1:end) = xW(end-halfWinLen+1:end).*winB;
    
    figure()
    [coeffs,d] = doPredictionWPlot(xH,fs);
    [outi,eOuti] = partAi(xH,coeffs);
    [outii,eOutii] = partAii(xH,coeffs);
    [outiii, eOutiii] = partAiii(xH,coeffs);
    [outiv, eOutiv] = partAiiii(xH,coeffs);
    
    %% Part ai
    outi(end-halfWinLen+1:end) = outi(end-halfWinLen+1:end) .* winB;
    eOuti(end-halfWinLen+1:end) = eOuti(end-halfWinLen+1:end) .* winB;
    reci((i-1)*jump+1:(i-1)*jump+halfWinLen) = outi(1:halfWinLen) + currWinBufi;
    reci((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = outi(halfWinLen+1:N-halfWinLen);
    excitationi((i-1)*jump+1:(i-1)*jump+halfWinLen) = eOuti(1:halfWinLen) + currEBufi;
    excitationi((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = eOuti(halfWinLen+1:N-halfWinLen);
    currWinBufi = outi(end-halfWinLen+1:end);
    currEBufi = eOuti(end-halfWinLen+1:end);
    
    %% Part aii
    outii(end-halfWinLen+1:end) = outii(end-halfWinLen+1:end) .* winB;
    eOutii(end-halfWinLen+1:end) = eOutii(end-halfWinLen+1:end) .* winB;
    recii((i-1)*jump+1:(i-1)*jump+halfWinLen) = outii(1:halfWinLen) + currWinBufii;
    recii((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = outii(halfWinLen+1:N-halfWinLen);
    excitationii((i-1)*jump+1:(i-1)*jump+halfWinLen) = eOutii(1:halfWinLen) + currEBufii;
    excitationii((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = eOutii(halfWinLen+1:N-halfWinLen);
    currWinBufii = outii(end-halfWinLen+1:end);
    currEBufii = eOutii(end-halfWinLen+1:end);
    
    %% Part aiii
    outiii(end-halfWinLen+1:end) = outiii(end-halfWinLen+1:end) .* winB;
    eOutiii(end-halfWinLen+1:end) = eOutiii(end-halfWinLen+1:end) .* winB;
    reciii((i-1)*jump+1:(i-1)*jump+halfWinLen) = outiii(1:halfWinLen) + currWinBufiii;
    reciii((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = outiii(halfWinLen+1:N-halfWinLen);
    excitationiii((i-1)*jump+1:(i-1)*jump+halfWinLen) = eOutiii(1:halfWinLen) + currEBufiii;
    excitationiii((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = eOutiii(halfWinLen+1:N-halfWinLen);
    currWinBufiii = outiii(end-halfWinLen+1:end);
    currEBufiii = eOutiii(end-halfWinLen+1:end);
    
    %% Part aiv
    outiv(end-halfWinLen+1:end) = outiv(end-halfWinLen+1:end) .* winB;
    eOutiv(end-halfWinLen+1:end) = eOutiv(end-halfWinLen+1:end) .* winB;
    reciv((i-1)*jump+1:(i-1)*jump+halfWinLen) = outiv(1:halfWinLen) + currWinBufiv;
    reciv((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = outiv(halfWinLen+1:N-halfWinLen);
    excitationiv((i-1)*jump+1:(i-1)*jump+halfWinLen) = eOutiv(1:halfWinLen) + currEBufiv;
    excitationiv((i-1)*jump+halfWinLen+1:(i-1)*jump+N-halfWinLen) = eOutiv(halfWinLen+1:N-halfWinLen);
    currWinBufiv = outiv(end-halfWinLen+1:end);
    currEBufiv = eOutiv(end-halfWinLen+1:end);
end

vec = 1:length(audioMd);

sVec = 2400:4000;

%% part i
err = abs(reci-audioMd);
plot(err(sVec));
title('Error between original and reconstructed signal');

figure();
vec = 1:length(audioMd);
plot(sVec,audioMd(sVec));
axis tight;
grid on;
title('Original Signal Superimposed over reconstructed signal');
hold on
plot(sVec,reci(sVec),'r');
axis tight; 
grid on;
hold off
 
sigRMS = rms(audioMd);
errRMS = rms(err);
pctEr = errRMS/sigRMS*100
 
soundsc(reci);

%% part ii
figure();
subplot(2,1,1);
plot(sVec,excitationii(sVec),'r');
title('Excitation (1 samp per period)');
axis tight;
grid on;
subplot(2,1,2);
plot(sVec,recii(sVec));
axis tight;
grid on;
title('Reconstruction (1 samp per period)');
hold off
soundsc(recii);

%% part iii
figure();
subplot(2,1,1);
plot(sVec,excitationiii(sVec),'r');
axis tight;
grid on;
title('Excitation (2 samp per period)');
subplot(2,1,2);
plot(sVec,reciii(sVec));
axis tight;
grid on;
title('Reconstruction (2 samp per period)');
soundsc(reciii);

%% part iv
figure();
subplot(2,1,1);
plot(sVec,excitationiv(sVec),'r');
axis tight;
grid on;
title('Excitation (4 samp per period)');
subplot(2,1,2);
plot(sVec,reciv(sVec));
axis tight;
grid on;
title('Reconstruction (4 samp per period)');
soundsc(reciv);








